#include <stdlib.h>

double dgemm(double *restrict x,double * restrict y,double * restrict z,int N) {
  int i,j,k;
#pragma xlang begin 
#pragma xlang parameter N [100,200]
#pragma xlang parameter Ui [1,2,4]
#pragma xlang parameter Uj [1,2,4]
#pragma xlang parameter Uk [1,2,4]
  for (i=0; i<N; i=i+1) {
    for (j=0; j<N; j++) {
      for (k=0; k<N; k++) {
	z[i*N+j] += x[i*N+k]* y[k*N+j];
      }
    } 
  }
#pragma xlang transform [interchange(i,j),interchange(j,k)]
#pragma xlang transform [interchange(i,j),interchange(j,k),interchange(i,k),nop]
#pragma xlang transform [interchange(i,j),interchange(j,k),interchange(i,k),nop]
#pragma xlang transform unroll(i,Ui)
#pragma xlang transform unroll(j,Uj)
#pragma xlang transform unroll(k,Uk)
#pragma xlang end
  return z[0];
}

